<template>
  <div class="app-container">
    <div class="operation">
      <el-button class="success" @click="form_add">新增</el-button>
      <el-button class="import" style="float: right;" @click="form_inport">导入</el-button>
      <el-dropdown style="float: right;margin-right: 10px;">
        <el-button class="export">导出</el-button>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item @click.native="form_export(1)">导出模板</el-dropdown-item>
          <el-dropdown-item @click.native="form_export(2)">导出数据</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
    </div>

    <div class="search">
      <el-date-picker v-model="table.getdataListParm.parammaps.inputDatetime" class="inputDatetime filter-item" type="daterange" range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期" style="width: 250px;" />
      <el-button class="el-icon-arrow-left elIconArrowLeft" @click="handleBefore" />
      <el-button class="el-icon-arrow-right elIconArrowRight" @click="handleNext" />
      <el-select v-model="table.getdataListParm.parammaps.usetype" placeholder="操作类型" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="(item,index) in operationTypeList" :key="index" :label="item.label" :value="item.value" />
      </el-select>
      <el-autocomplete v-model="table.getdataListParm.parammaps.feedname" value-key="feedname" class="inline-input filter-item" :fetch-suggestions="tableFeedNameSearch" placeholder="饲料名称" style="width:250px" @select="handleSelectTableFeedName">
        <template slot-scope="{ item }">
          <span>{{ item.feedname }}</span>
        </template>
      </el-autocomplete>
      <el-select v-model="table.getdataListParm.parammaps.cowclassid" filterable placeholder="请选择牲畜类别" class="filter-item" style="width: 150px;" clearable>
        <el-option v-for="(item,index) in livestockList" :key="index" :label="item.mixname" :value="item.id" />
      </el-select>
      <el-button class="successBorder" @click="form_search">查询</el-button>
      <el-button class="successBorder" @click="form_clear">重置</el-button>
    </div>

    <div class="table">
      <el-table :key="table.tableKey" v-loading="table.listLoading" element-loading-text="给我一点时间" :data="table.list" border fit highlight-current-row style="width: 100%;" :row-style="rowStyle" :cell-style="cellStyle" class="elTable table-fixed">
        <el-table-column label="序号" align="center" type="index" width="50px">
          <template slot-scope="scope">
            <span>{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="出库日期" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.usedate }}</span>
          </template>
        </el-table-column>
        <el-table-column label="牲畜类别" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.cowclass }}</span>
          </template>
        </el-table-column>
        <el-table-column label="饲料名称" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.feedname }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作重量（kg）" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.operateweight }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作类型" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.usetype }}</span>
          </template>
        </el-table-column>
        <el-table-column label="备注" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.remark }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作人" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.createemp }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="120" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <el-button class="miniPrimary" @click="form_see(row)">查看</el-button>
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="table.total>=0" :total="table.total" :page.sync="table.getdataListParm.offset" :limit.sync="table.getdataListParm.pagecount" @pagination="get_table_data" />
    </div>

    <!-- 新增/编辑 -->
    <el-dialog :title="textMap[create.dialogStatus]" :visible.sync="create.dialogFormVisible" :close-on-click-modal="false" width="80%">
      <div class="app-add">
        <el-form ref="createTemp" :rules="create.rules" :model="create.createTemp" label-position="right" label-width="150px" style="width: 90%;height:300px;margin:0 auto 50px">
          <el-row>
            <el-col :span="12">
              <el-form-item label="操作类型：" prop="usetype">
                <el-select v-model="create.createTemp.usetype" placeholder="操作类型" class="filter-item" style="width: 100%;" :disabled="create.dialogStatus==='see'" @change="changeUsetype">
                  <el-option v-for="(item,index) in operationTypeList" :key="index" :label="item.label" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="12">
              <el-form-item label="出库日期：" prop="usedate">
                <el-date-picker v-model="create.createTemp.usedate" :picker-options="create.pickerOptions1" :clearable="false" class="filter-item" format="yyyy-MM-dd" value-format="yyyy-MM-dd" style="width: 100%;" type="datetime" placeholder="出库日期" :disabled="create.dialogStatus==='see'" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="12">
              <el-form-item label="饲料名称：" prop="feedname">
                <el-autocomplete v-model="create.createTemp.feedname" :disabled="create.dialogStatus==='see'" value-key="feedname" class="inline-input" :fetch-suggestions="feedNameSearch" placeholder="请选择饲料名称" style="width:100%" @select="handleSelectFeedName" @blur="blurFeedName">
                  <template slot-scope="{ item }">
                    <span>{{ item.feedname }}</span>
                  </template>
                </el-autocomplete>
              </el-form-item>
              </el-form-item>
            </el-col>
            <el-col :span="12">
              <el-form-item label="牲畜类别：" prop="cowclassid">
                <el-select v-model="create.createTemp.cowclassid" filterable placeholder="请选择牲畜类别" class="filter-item" style="width: 100%;" :disabled="create.dialogStatus==='see' || create.createTemp.usetype=='损耗'" @change="changeLivestock">
                  <el-option v-for="(item,index) in livestockList" :key="index" :label="item.mixname" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="12">
              <el-form-item label="库存重量（kg）：" prop="repertoryweight">
                <el-input ref="repertoryweight" v-model="create.createTemp.repertoryweight" class="filter-item" placeholder="最多两位小数" type="text" disabled />
              </el-form-item>
            </el-col>
            <el-col :span="12">
              <el-form-item label="操作重量（kg）：" prop="operateweight">
                <el-input ref="operateweight" v-model="create.createTemp.operateweight" class="filter-item" placeholder="最多两位小数" type="text" :disabled="create.dialogStatus==='see'" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="12">
              <el-form-item label="备注：" prop="remark">
                <el-input ref="remark" v-model="create.createTemp.remark" class="filter-item" placeholder="1-255字符" type="text" :disabled="create.dialogStatus==='see'" />
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button class="cancelClose" @click="create.dialogFormVisible = false; ">关闭</el-button>
          <el-button v-if="create.dialogStatus==='create'" class="success" :disabled="isokDisable" @click="add_dialog_save()">确认</el-button>
        </div>
      </div>
    </el-dialog>

  </div>

</template>

<script>
import { GetDataByName, GetDataByNames, checkButtons, calculativeWidth, ExecDataByConfig, failproccess } from '@/api/common'
import Pagination from '@/components/Pagination'
import Cookies from 'js-cookie'
import { parseTime } from '@/utils/index.js'
export default {
  name: 'LaborConsumption',
  components: { Pagination },
  data() {
    return {
      isRoleEdit: [],
      send_select_list: [
        { name: 'getDictByName', offset: 0, pagecount: 0, params: ['人工用量操作类型'] },
        { name: 'getCowclassListEnable', offset: 0, pagecount: 0, parammaps: { 'pastureid': Cookies.get('pastureid') } }
      ],
      operationTypeList: [], // 操作类型
      feedNameList: [], // 饲料名称
      livestockList: [], // 牲畜类别

      table: {
        getdataListParm: {
          name: 'getFeeduseList',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            inputDatetime: '',
            pastureid: Cookies.get('pastureid'),
            startTime: '',
            stopTime: '',
            usetype: '',
            feedid: '',
            cowclassid: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true
      },

      create: {
        pickerOptions1: {
          disabledDate(time) {
            return time.getTime() > Date.now()// 当天之前的时间可选
          }
        },
        dialogFormVisible: false,
        dialogStatus: '',
        createTemp: {
          pastureid: Cookies.get('pastureid'), usedate: parseTime(new Date(), '{y}-{m}-{d}'), feedid: '', feedname: '', cowclassid: '', cowclass: '', usetype: '', operateweight: '', repertoryweight: '', createemp: '', remark: '', price: ''
        },
        getfeedNameParm: {
          name: 'getFeedstorageuse',
          offset: 0,
          pagecount: '',
          parammaps: { pastureid: Cookies.get('pastureid') }
        },
        rules: {
          usetype: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          usedate: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          feedname: [{ type: 'string', required: true, message: '必填', trigger: 'change' }],
          operateweight: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }]
        }
      },

      textMap: {
        create: '新增',
        see: '查看'
      },
      requestParam: {},
      isokDisable: false,
      rowStyle: { maxHeight: 50 + 'px', height: 45 + 'px' },
      cellStyle: { padding: 0 + 'px' }

    }
  },
  created() {
    this.get_table_data()
    this.get_select_list()
    this.get_auto_buttons()
  },

  methods: {
    get_auto_buttons() {
      const Edit = 'SystemConsumption'
      const isRoleEdit = checkButtons(JSON.parse(sessionStorage.getItem('buttons')), Edit)
      this.isRoleEdit = isRoleEdit
    },
    get_select_list() {
      GetDataByNames(this.send_select_list).then(response => {
        this.operationTypeList = response.data.getDictByName.list
        this.livestockList = response.data.getCowclassListEnable.list
      })
    },
    handleBefore() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() - 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() - 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.table.getdataListParm.parammaps.startTime = parseTime(start, '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(stop, '{y}-{m}-{d}')
        this.$forceUpdate()
      }
    },
    handleNext() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() + 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() + 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.table.getdataListParm.parammaps.startTime = parseTime(start, '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(stop, '{y}-{m}-{d}')
        this.$forceUpdate()
      }
    },
    get_table_data() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
          this.table.total = response.data.total
        } else {
          this.table.list = []
        }
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },

    form_search() {
      console.log('点击了查询')
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        this.table.getdataListParm.parammaps.startTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
      } else {
        this.table.getdataListParm.parammaps.inputDatetime = ''
        this.table.getdataListParm.parammaps.startTime = ''
        this.table.getdataListParm.parammaps.stopTime = ''
      }
      this.table.getdataListParm.offset = 1
      this.get_table_data()
    },
    form_clear() {
      console.log('点击了重置')
      this.table.getdataListParm.parammaps.inputDatetime = ''
      this.table.getdataListParm.parammaps.startTime = ''
      this.table.getdataListParm.parammaps.stopTime = ''
      this.table.getdataListParm.parammaps.feedid = ''
      this.table.getdataListParm.parammaps.cowclassid = ''
      this.table.getdataListParm.parammaps.ischarge = ''
      this.table.getdataListParm.parammaps.usetype = ''
      this.table.getdataListParm.parammaps.feedname = ''
      this.table.getdataListParm.parammaps.cowclassid = ''
    },
    resetCreateTemp() {
      this.create.createTemp = {
        pastureid: Cookies.get('pastureid'), usedate: parseTime(new Date(), '{y}-{m}-{d}'), feedid: '', feedname: '', cowclassid: '', cowclass: '', usetype: '', operateweight: '', repertoryweight: '', createemp: Cookies.get('employename'), remark: '', price: ''
      }
    },
    // 操作类型
    changeUsetype(item) {
      console.log(item)
      if (item == '损耗') {
        console.log(item)
        this.create.createTemp.cowclassid = ''
        this.create.createTemp.cowclass = ''
      }
    },
    tableFeedNameSearch(queryString, cb) {
      this.create.getfeedNameParm.parammaps['feedname'] = queryString
      GetDataByName(this.create.getfeedNameParm).then(response => {
        console.log('模糊查询搜索data', response.data.list)
        if (response.data.list == null) {
          cb([])
        } else {
          cb(response.data.list)
        }
      })
    },
    handleSelectTableFeedName(item) {
      this.table.getdataListParm.parammaps.feedid = item.feedid
    },
    // 饲料名称
    feedNameSearch(queryString, cb) {
      this.create.getfeedNameParm.parammaps['feedname'] = queryString
      GetDataByName(this.create.getfeedNameParm).then(response => {
        console.log('模糊查询搜索data', response.data.list)
        if (response.data.list == null) {
          cb([])
        } else {
          cb(response.data.list)
        }
      })
    },
    handleSelectFeedName(item) {
      console.log(item)
      this.create.createTemp.feedname = item.feedname
      this.create.createTemp.feedid = item.feedid
      this.create.createTemp.price = item.price
      this.create.createTemp.pcpde = item.pcpde
      this.create.createTemp.repertoryweight = item.stockweight
    },
    blurFeedName() {
      this.create.createTemp.feedname = ''
      this.create.createTemp.feedid = ''
      this.create.createTemp.price = ''
      this.create.createTemp.pcpde = ''
      this.create.createTemp.repertoryweight = ''
    },
    // 牲畜类别
    changeLivestock(item) {
      this.create.createTemp.cowclass = this.livestockList.find(obj => obj.id == item).classname
    },
    form_add() {
      console.log('点击了新增')
      this.resetCreateTemp()
      this.create.dialogStatus = 'create'
      this.create.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs.createTemp.resetFields()
      })
    },
    add_dialog_save() {
      console.log('点击了新增保存')
      this.$refs['createTemp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          if (this.create.createTemp.usetype == '人工用料') {
            if (this.create.createTemp.cowclassid == '') {
              this.$message({ type: 'error', message: '请选择牲畜类别', duration: 2000 })
              return false
            }
          }
          const keepTwoNum = /^\d+(\.\d{1,2})?$/
          // 操作重量
          if (this.create.createTemp.operateweight == 0) {
            this.$message({ type: 'error', message: '操作重量请输入自然数并保留两位小数', duration: 2000 })
            return false
          } else {
            if (!keepTwoNum.test(parseFloat(this.create.createTemp.operateweight))) {
              this.$message({ type: 'error', message: '操作重量请输入自然数并保留两位小数', duration: 2000 })
              return false
            }
          }

          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = {            'name': 'insertFeeduse', 'type': 'e', 'parammaps': {
              'pastureid': this.create.createTemp.pastureid,
              'usedate': this.create.createTemp.usedate,
              'feedid': this.create.createTemp.feedid,
              'feedname': this.create.createTemp.feedname,
              'cowclassid': this.create.createTemp.cowclassid,
              'cowclass': this.create.createTemp.cowclass,
              'usetype': this.create.createTemp.usetype,
              'operateweight': this.create.createTemp.operateweight,
              'repertoryweight': this.create.createTemp.repertoryweight,
              'createemp': this.create.createTemp.createemp,
              'remark': this.create.createTemp.remark,
              'price': this.create.createTemp.price
            }          }
          this.requestParam.data[1] = {            'name': 'insertFeedstorageUse', 'type': 'e', 'parammaps': {
              'pastureid': this.create.createTemp.pastureid,
              'feedid': this.create.createTemp.feedid,
              'operateweight': this.create.createTemp.operateweight,
              'fname': this.create.createTemp.feedname,
              'pcpde': this.create.createTemp.pcpde,
              'price': this.create.createTemp.price
            }          }
          ExecDataByConfig(this.requestParam).then(response => {
            if (response.msg === 'fail') {
              failproccess(response, this.$notify)
            } else {
              this.$notify({ title: '', message: '成功', type: 'success', duration: 2000 })
              this.create.dialogFormVisible = false
              this.get_table_data()
            }
          })
        }
      })
    },
    form_see(row) {
      console.log('点击了查看')
      this.create.dialogStatus = 'see'
      this.create.dialogFormVisible = true
      this.create.createTemp = Object.assign({}, row)
      this.$nextTick(() => {
        this.$refs.createTemp.resetFields()
      })
    },
    form_delete(row) {
      console.log('点击了行内删除')
    },
    // 导出
    form_export(item) {
      if (item == 1) {
        console.log('点击了导出模板')
      } else {
        console.log('点击了导出数据')
      }
    },

    // 导入
    form_inport() {
      console.log('点击了导入')
    }
  }
}
</script>
<style lang="scss" scoped>
.search {
  margin-top: 10px;
}
.table {
  margin-top: 10px;
}
</style>
 <style lang="scss">
.typeSelect span .el-popover__reference .el-input--suffix {
  .el-input__inner {
    height: 40px !important;
  }
}
</style>
